#pragma semicolon 1
#include <sourcemod>

// вызов меню
#define X_CMD "color"

public Plugin:myinfo = 
{
	name = "Skin_Color",
	author = "wS / Schmidt",
	description = "Выбор цвета для скина",
	version = "1.0",
	url = "http://world-source.ru/"
};

new String:wS_ColorName[51][35],
	wS_rgba[51][4],
	wS_PlayerColorNum[MAXPLAYERS+1],
	wS_PlayerNewColorNum[MAXPLAYERS+1],
	max_color;

public OnPluginStart()
{
	HookEvent("player_spawn", player_spawn);
	HookEvent("round_start", round_start, EventHookMode_PostNoCopy);
	RegConsoleCmd(X_CMD, say_X_CMD);
}

public OnMapStart()
{
	new Handle:kv = CreateKeyValues("skin_color");
	if (!FileToKeyValues(kv, "cfg/skin_color.txt"))
	{
		CloseHandle(kv);
		SetFailState("Ошибка в cfg/skin_color.txt");
		return;
	}
	new r, g, b, a;
	decl String:str_num[3];
	for (new x = 1; x < 51; x++)
	{
		IntToString(x, str_num, 3);
		if (!KvJumpToKey(kv, str_num))
		{
			if (x == 1)
			{
				CloseHandle(kv);
				SetFailState("Цвет №1 не найден в cfg/skin_color.txt!");
			}
			break;
		}
		KvGetString(kv, "color_name", wS_ColorName[x], 75);
		KvGetColor(kv, "color_rgba", r, g, b, a);
		KvRewind(kv);
		wS_rgba[x][0] = r;
		wS_rgba[x][1] = g;
		wS_rgba[x][2] = b;
		wS_rgba[x][3] = a;
		max_color = x;
	}
	CloseHandle(kv);
}

public player_spawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	new c = wS_PlayerColorNum[client];
	if (c > 0 && GetClientTeam(client) > 1)
	{
		SetEntityRenderMode(client, RENDER_TRANSCOLOR);
		SetEntityRenderColor(client, wS_rgba[c][0], wS_rgba[c][1], wS_rgba[c][2], wS_rgba[c][3]);
	}
}

public OnClientPutInServer(client)
{
	wS_PlayerColorNum[client] = 0;
	wS_PlayerNewColorNum[client] = 1;
}

public Action:say_X_CMD(client, args)
{
	if (client > 0 && args < 1) ShowMenu(client);
	return Plugin_Handled;
}

ShowMenu(client)
{
	new Handle:p = CreatePanel();
	SetPanelTitle(p, "Выбор Цвета Скина\n------------------------------------\n \n");

	decl String:f[128];
	if (wS_PlayerColorNum[client] > 0)
	{
		Format(f, sizeof(f), "Текущий цвет: %s\n \n", wS_ColorName[wS_PlayerColorNum[client]]);
		DrawPanelText(p, f);
	}
	else DrawPanelText(p, "Текущий цвет: Стандартный\n \n");

	Format(f, sizeof(f), "Выбрать другой: < %s >", wS_ColorName[wS_PlayerNewColorNum[client]]);
	DrawPanelItem(p, f);
	DrawPanelItem(p, "СОХРАНИТЬ изменения\n \n");
	DrawPanelItem(p, "Выход");

	SendPanelToClient(p, client, Select_Menu, 0);
	CloseHandle(p);
}

public Select_Menu(Handle:menu, MenuAction:action, client, option)
{
	if (action != MenuAction_Select) return;
	if (option == 1)
	{
		if (++wS_PlayerNewColorNum[client] > max_color) wS_PlayerNewColorNum[client] = 1;
		ShowMenu(client);
	}
	else if (option == 2)
	{
		new c = wS_PlayerColorNum[client];
		new n = wS_PlayerNewColorNum[client];
		if (wS_rgba[c][0] == wS_rgba[n][0] && wS_rgba[c][1] == wS_rgba[n][1] && wS_rgba[c][2] == wS_rgba[n][2] && wS_rgba[c][3] == wS_rgba[n][3])
		{
			PrintToChat(client, "У вас и так этот цвет..");
		}
		else
		{
			wS_PlayerColorNum[client] = n;
			PrintToChat(client, "Изменения вступят в силу в следующем раунде");
			ShowMenu(client);
		}
	}
}

public round_start(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetRandomInt(1, 5) == 3) PrintToChatAll("Хотите сменить цвет скина? (%s, !%s, /%s)", X_CMD, X_CMD, X_CMD);
}